# TensorFlow

TensorFlow is an open-source software library for machine intelligence.

## TensorFlow modules

Anselm provides three different TensorFlow modules:
 * Tensorflow/1.1.0
 * Tensorflow/1.1.0-CUDA-7.5.18-Python-3.6.1
 * Tensorflow/1.1.0-CUDA-8.0.44-Python-3.6.1

### Tensorflow/1.1.0 (CPU only)

TensorFlow 1.1 build. 

```console
$ ml Tensorflow/1.1.0
```

This module was built with:
 * GCC/4.9.3
 * Python/3.6.1

### Tensorflow/1.1.0-CUDA-7.5.18-Python-3.6.1 (GPU enabled)

TensorFlow 1.1 with GPU support.

```console
$ ml Tensorflow/1.1.0-CUDA-7.5.18-Python-3.6.1
```

This module was built with:
 * GCC/4.9.3
 * Python/3.6.1
 * CUDA/7.5.18
 * cuDNN/5.1-CUDA-7.5.18

### Tensorflow/1.1.0-CUDA-8.0.44-Python-3.6.1  (GPU enabled)

TensorFlow 1.1 with GPU support.

```console
$ ml Tensorflow/1.1.0-CUDA-8.0.44-Python-3.6.1
```

This module was built with:
 * GCC/4.9.3
 * Python/3.6.1
 * CUDA/8.0.44
 * cuDNN/5.1-CUDA-8.0.44

## TensorFlow application example

After loading one of the available TensorFlow modules, you can check the functionality running the following python script.

```python
import tensorflow as tf

c = tf.constant('Hello World!')
sess = tf.Session()
print(sess.run(c))
```
